<template>
  <div class="app-container">

    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-input v-model="listQuery.name" clearable class="filter-item" style="width: 200px;" placeholder="请输入技能组" />
      <el-button v-permission="['GET /admin/skill/list']" class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button v-permission="['POST /admin/skill/create']" class="filter-item" type="primary" icon="el-icon-edit" @click="handleCreate">添加</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table v-loading="listLoading" :data="list" element-loading-text="正在查询中。。。" border fit highlight-current-row>

      <el-table-column align="center" label="技能组名称" prop="name" />

      <el-table-column align="center" label="是否有升级工单处理权限" prop="isUpgrade">
        <template slot-scope="scope">
          <el-tag :type="scope.row.isUpgrade?'warning':'success'">{{ scope.row.isUpgrade | boolenFilter }}</el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="是否有打开已完成工单权限" prop="isReopen">
        <template slot-scope="scope">
          <el-tag :type="scope.row.isReopen?'warning':'success'">{{ scope.row.isReopen | boolenFilter }}</el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="描述" prop="remark" />
      <el-table-column align="center" label="状态" prop="deleted">
        <template slot-scope="scope">
          <span v-if="scope.row.deleted == true">已停用</span>
          <span v-else>正常</span>
        </template>
      </el-table-column>

      <el-table-column align="center" label="操作" width="250" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-permission="['POST /admin/skill/update']" type="primary" size="mini" @click="handleUpdate(scope.row)">编辑</el-button>
          <el-button v-permission="['POST /admin/skill/delete']" type="danger" size="mini" @click="handleDelete(scope.row)">删除</el-button>
          <el-button v-permission="['POST /admin/skill/binding']" type="primary" size="mini" @click="handleGroupUsers(scope.row)">成员</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit" @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="dataForm" status-icon label-position="left" label-width="180px" style="width: 500px; margin-left:50px;">
        <el-form-item label="技能组名称" prop="name">
          <el-input v-model="dataForm.name" />
        </el-form-item>

        <el-form-item label="升级工单处理权限" prop="isUpgrade">
          <el-radio-group v-model="dataForm.isUpgrade">
            <el-radio :label="false">无</el-radio>
            <el-radio :label="true">有</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item label="重新打开完成工单权限" prop="isReopen">
          <el-radio-group v-model="dataForm.isReopen">
            <el-radio :label="0">无</el-radio>
            <el-radio :label="1">有</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item label="描述" prop="remark">
          <el-input v-model="dataForm.remark" />
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus=='create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

    <!-- 技能组成员对话框 -->
    <el-dialog :visible.sync="dialogAdminVisible" title="技能组成员设置">
      <el-tree
        ref="tree"
        :data="sysUsers"
        :default-checked-keys="assignedUsers"
        show-checkbox
        node-key="id"
        highlight-current
      >
        <span slot-scope="{ node, data }" class="custom-tree-node">
          <span>{{ data.label }}</span>
        </span>
      </el-tree>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogAdminVisible = false">取消</el-button>
        <el-button type="primary" @click="updateGroupUsers">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { listSkill, createSkill, updateSkill, deleteSkill, getSkill, bingdingSkill } from '@/api/skill'
import Pagination from '@/components/Pagination' // Secondary package based on el-pagination

export default {
  name: 'Skill',
  components: { Pagination },
  filters: {
    boolenFilter(value) {
      if (value) return '有'
      else return '无'
    }
  },
  data() {
    return {
      list: null,
      total: 0,
      assignedUsers: [],
      sysUsers: [],
      listLoading: true,
      listQuery: {
        name: undefined,
        page: 1,
        limit: 20,
        sort: 'create_time',
        order: 'desc'
      },
      dataForm: {
        id: undefined,
        name: '',
        isUpgrade: true,
        isReopen: false,
        deleted: false
      },
      dialogFormVisible: false,
      dialogAdminVisible: false,
      dialogStatus: '',
      textMap: {
        update: '编辑',
        create: '创建'
      },
      rules: {
        name: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
        isUpgrade: [{ required: true, message: '请选择升级工单权限', trigger: 'blur' }],
        isReopen: [{ required: true, message: '请选择重新打开工单权限', trigger: 'blur' }]
      },
      usesForm: {
        groupId: undefined,
        admins: []
      }

    }
  },
  created() {
    this.getList()
  },
  methods: {
    getList() {
      this.listLoading = true
      listSkill(this.listQuery).then(response => {
        this.list = response.data.data.list
        this.total = response.data.data.total
        this.listLoading = false
      }).catch(() => {
        this.list = []
        this.total = 0
        this.listLoading = false
      })
    },
    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },
    resetForm() {
      this.dataForm = {
        id: undefined,
        name: undefined,
        isUpgrade: true,
        isReopen: false,
        remark: undefined
      }
    },
    handleCreate() {
      this.resetForm()
      this.dialogStatus = 'create'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    createData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          createSkill(this.dataForm).then(response => {
            this.list.unshift(response.data.data)
            this.dialogFormVisible = false
            this.$notify.success({
              title: '成功',
              message: '创建成功'
            })
          }).catch(response => {
            this.$notify.error({
              title: '失败',
              message: response.data.errmsg
            })
          })
        }
      })
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row)
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          updateSkill(this.dataForm).then(() => {
            for (const v of this.list) {
              if (v.id === this.dataForm.id) {
                const index = this.list.indexOf(v)
                this.list.splice(index, 1, this.dataForm)
                break
              }
            }
            this.dialogFormVisible = false
            this.$notify.success({
              title: '成功',
              message: '更新成功'
            })
          }).catch(response => {
            this.$notify.error({
              title: '失败',
              message: response.data.errmsg
            })
          })
        }
      })
    },
    handleDelete(row) {
      deleteSkill(row).then(response => {
        this.$notify.success({
          title: '成功',
          message: '删除成功'
        })
        const index = this.list.indexOf(row)
        this.list.splice(index, 1)
      }).catch(response => {
        this.$notify.error({
          title: '失败',
          message: response.data.errmsg
        })
      })
    },
    handleGroupUsers(row) {
      this.dialogAdminVisible = true
      this.usesForm.groupId = row.id
      getSkill({ groupId: row.id })
        .then(response => {
          this.assignedUsers = response.data.data.assignedUsers
          this.sysUsers = response.data.data.allUsers
          console.info(this.assignedUsers)
        })
    },
    updateGroupUsers() {
      this.usesForm.admins = this.$refs.tree.getCheckedKeys(true)
      console.info(this.usesForm)
      bingdingSkill(this.usesForm)
        .then(response => {
          this.dialogAdminVisible = false
          this.$notify.success({
            title: '成功',
            message: '授权成功'
          })
        })
        .catch(response => {
          this.$notify.error({
            title: '失败',
            message: response.data.errmsg
          })
        })
    }
  }
}
</script>

